#ifndef _FIREFLY_BIT_H_
#define _FIREFLY_BIT_H_

#include "stl/stdint.hpp"

stl::UInt32T par32(const stl::UInt32T x, const stl::UInt32T y
    , const stl::UInt32T z);

stl::UInt32T shr32(const stl::UInt32T x, const stl::UInt32T n);

stl::UInt32T rotl32(const stl::UInt32T x, const stl::UInt32T n);

stl::UInt32T rotr32(const stl::UInt32T x, const stl::UInt32T n);

stl::UInt32T ch32(const stl::UInt32T x, const stl::UInt32T y, const stl::UInt32T z);

stl::UInt32T maj32(const stl::UInt32T x, const stl::UInt32T y, const stl::UInt32T z);

stl::UInt64T shr64(const stl::UInt64T x, const stl::UInt64T n);

stl::UInt64T rotr64(const stl::UInt64T x, const stl::UInt64T n);

stl::UInt64T ch64(const stl::UInt64T x, const stl::UInt64T y, const stl::UInt64T z);

stl::UInt64T maj64(const stl::UInt64T x, const stl::UInt64T y, const stl::UInt64T z);

#endif
