#ifndef _FIREFLY_SHA_TYPES_H_
#define _FIREFLY_SHA_TYPES_H_

#include "stl/stdint.hpp"
#include "stl/compile_info.hpp"

#if !defined NULL
#define NULL ((void*)0)
#endif

#if !defined SIZEOF
#define SIZEOF(s, e) sizeof(((const s*)NULL)->e)
#endif

#define CRYPTO_LITTLE_ENDIAN CI_PLATFORM_ENDIAN_LITTLE
#define CRYPTO_BIG_ENDIAN CI_PLATFORM_ENDIAN_BIG

#define CRYPTO_ENDIAN CI_PLATFORM_ENDIAN

#if !defined pgm_read_u32
#define pgm_read_u32 *
#endif

#if !defined pgm_read_u64
#define pgm_read_u64 *
#endif

typedef stl::UInt64T size64_t;
typedef size64_t size128_t;

#endif // _SHA_TYPES_H_
