#ifndef __STL_DEBUG_HPP__
#define __STL_DEBUG_HPP__

#include "compile_info.hpp"

#if defined CI_COMPILER_MSC
#define DEBUG_BREAK() DebugBreak()
#elif defined CI_COMPILER_CLANG
#include <signal.h>
#define DEBUG_BREAK() raise(SIGTRAP)
#elif defined CI_COMPILER_GNUC
#include <signal.h>
#define DEBUG_BREAK() raise(SIGTRAP)
#else
#define DEBUG_BREAK()
#endif

#endif