#ifndef _STDINT_HPP_
#define _STDINT_HPP_

#include "stl/stl_config.hpp"

#include <cstdint>

namespace stl {
    // TODO: Also char can have different size on different platforms (even 7 bits)

    using Int8T = std::int8_t;
    using UInt8T = std::uint8_t;

    using Int16T  = std::int16_t;
    using UInt16T = std::uint16_t;

    using Int32T  = std::int32_t;
    using UInt32T = std::uint32_t;

#ifdef STL_ENABLE_INT64
    using Int64T  = std::int64_t;
    using UInt64T = std::uint64_t;
#endif
}

#endif
