#include "stl/compile_info.hpp"

#include "stl/allocate.hpp"
#include "stl/mutex.hpp" // Mutex wrapper itself cannot be used

#if defined CI_PLATFORM_MKRWIFI1010 && (CI_PLATFORM_MKRWIFI1010 == 1)
#include "FreeRTOS.h"
#include "portable.h"
#include "projdefs.h"
#include "semphr.h"
#else
#include <mutex>
#endif

// #include <stdlib.h>

/* #if defined CI_PLATFORM_MKRWIFI1010 && (CI_PLATFORM_MKRWIFI1010 == 1)
class MutexInternal : public stl::Lockable
{
public:
    MutexInternal() : m_semaphoreHandle(xSemaphoreCreateMutex())
    {
        Assert(m_semaphoreHandle);
    }

    ~MutexInternal()
    {
        Assert(m_semaphoreHandle);
        vSemaphoreDelete(m_semaphoreHandle);
    }

    void lock() { xSemaphoreTake(m_semaphoreHandle, portMAX_DELAY); }

    void unlock() { xSemaphoreGive(m_semaphoreHandle); }

    bool tryLock() { return xSemaphoreTake(m_semaphoreHandle, 0) == pdPASS; }

private:
    xSemaphoreHandle m_semaphoreHandle;
};
#else
class MutexInternal : public stl::Lockable
{
public:
    MutexInternal() {}

    ~MutexInternal() {}

    void lock() { m_lock.lock(); }

    void unlock() { m_lock.unlock(); }

    bool tryLock() { return m_lock.try_lock(); }

private:
    std::mutex m_lock;
};
#endif */

// static MutexInternal g_allocationLock;

namespace stl::memory
{
MemoryManagerBase::MemoryManagerBase() {}

MemoryManagerBase::~MemoryManagerBase() {}

SizeT MemoryManagerBase::m_allocated = 0U;

SizeT MemoryManagerBase::allocated()
{
    SizeT retv;
    {
        // LockGuard<Mutex> lock(g_allocationLock);
        retv = m_allocated;
    }

    return retv;
}

/*
void* MemoryManagerBase::allocateArrayInternal(SizeT size)
{
    // LockGuard<Mutex> lock(g_allocationLock);

    void* ptr =
#if defined CI_PLATFORM_MKRWIFI1010 && (CI_PLATFORM_MKRWIFI1010 == 1)
        pvPortMalloc(size);
        // malloc(size);
#else
        reinterpret_cast<void*>(new stl::UInt8T[size]);
#endif

    m_allocated += size;

    return ptr;
}

void MemoryManagerBase::deallocateArrayInternal(void* ptr)
{
    // LockGuard<Mutex> lock(g_allocationLock);

    Assert(ptr);

    if (!ptr)
    {
        return;
    }

    // TODO: m_allocated decrease

#if defined CI_PLATFORM_MKRWIFI1010 && (CI_PLATFORM_MKRWIFI1010 == 1)
    vPortFree(static_cast<void*>(ptr));
    // free(static_cast<void*>(ptr));
#else
    delete[] ptr;
#endif
} */
} // namespace stl::memory
 