#include "stl/compile_info.hpp"
#include "stl/compiler.hpp"
#include "stl/stl_config.hpp"

#include "stl/iostream.hpp"
#include "stl/stddef.hpp"
#include "stl/thread.hpp"
#include "stl/proces.hpp"

#include <iostream>

#if ((defined CI_SUPPORT_STD && (CI_SUPPORT_STD == 1)) &&                      \
     (defined STL_ENABLE_ASSERT && (STL_ENABLE_ASSERT == 1)))

extern volatile bool serviceStop;

namespace stl {
bool
_Assert(const bool expr, const char* file, const SizeT line)
{
  if (!expr) {
    ::std::cout << "[assert] " << file << " #" << line << ::std::endl;
    ::std::cout.flush();
    
    proces::terminate(-1);

    return false;
  }

  return true;
}
}

#endif
