#include "stl/compile_info.hpp"
#include "stl/stl_config.hpp"

#if defined CI_PLATFORM_MKRWIFI1010 && (CI_PLATFORM_MKRWIFI1010 == 1)

#include "samd21/include/samd21g18a.h" // TODO: CPU specific
#include "core_cm0plus.h"

#include "stl/iostream.hpp"

namespace stl::proces
{
void terminate(const int errorCode)
{
    __disable_irq();
    NVIC_SystemReset();
}

void panic()
{
    stl::cout << "*** SYSTEM PANICKED! ***" << stl::endl;

    while (true)
    {
    }
}
} // namespace stl::proces

#endif
