#ifndef _RC4_H_
#define _RC4_H_

#include "stl/stdint.hpp"
#include "crypto/crypto_types.h"

int RC4_ksa(const stl::UInt8T *const key, const stl::UInt32T key_length
    , stl::UInt8T ks[256]);
int RC4_prga(stl::UInt8T ks[256], const stl::UInt8T *input, stl::SizeT input_size
    , stl::UInt8T *output);

#endif
