#ifndef _STL_RANDOM_HPP_
#define _STL_RANDOM_HPP_

#include <random>

namespace stl::random {
  void seed(const int seed) {}

  template<typename T>
  T random(const T min, const T max)
  {
    std::random_device dev;
    std::mt19937 rng(dev());
    std::uniform_int_distribution<std::mt19937::result_type> dist6(min, max);

    return dist6(rng);
  }
}

#endif // _STL_RANDOM_HPP_