#ifndef _STDDEF_HPP_
#define _STDDEF_HPP_

#include "stl/stl_config.hpp"
#include "stl/stdint.hpp"

namespace stl {
#if defined STL_SET_SIZE_T_8
    using SizeT = UInt8T;
#elif defined STL_SET_SIZE_T_16
    using SizeT = UInt16T;
#elif defined STL_SET_SIZE_T_32
    using SizeT = UInt32T;
#elif defined STL_SET_SIZE_T_64
    using SizeT = UInt64T;
#endif

#if defined STL_SET_SIZE_T_8
    using SSizeT = Int8T;
#elif defined STL_SET_SIZE_T_16
    using SSizeT = Int16T;
#elif defined STL_SET_SIZE_T_32
    using SSizeT = Int32T;
#elif defined STL_SET_SIZE_T_64
    using SSizeT = Int64T;
#endif
}

#endif
