#include "stl/math.hpp"

namespace stl::math::vec {
Vec2
operator+(Vec2 a, Vec2 b)
{
  return Vec2(a.x + b.x, a.y + b.y);
}

Vec2
operator-(Vec2 a, Vec2 b)
{
  return Vec2(a.x - b.x, a.y - b.y);
}

Vec2
operator*(float s, Vec2 a)
{
  return Vec2(s * a.x, s * a.y);
}
}