#include "stl/compile_info.hpp"
#include "stl/stl_config.hpp"

#if (defined CI_SUPPORT_STD && (CI_SUPPORT_STD == 1))

#include "stl/ostream.hpp"

#include <iostream>

namespace stl::stream {
void
OStream::flush()
{
  std::cout.flush();
}

SizeT
OStream::write(const UInt8T* const data, SizeT size)
{
  std::cout.write(reinterpret_cast<const char*>(data),
                  static_cast<std::streamsize>(size));

  return size;
}

bool
OStream::seek(const SizeT offset, const SeekModeE seekMode)
{
  return false;
}
} // namespace stl::proces

#endif
