#include "stl/compile_info.hpp"
#include "stl/stl_config.hpp"

#if (defined CI_SUPPORT_STD && (CI_SUPPORT_STD == 1))

#include "stl/iostream.hpp"
#include "stl/thread.hpp"

#include <cstdlib>

namespace stl::proces
{
void terminate(const int errorCode) { exit(errorCode); }

void panic()
{
    stl::cout << "*** SYSTEM PANICKED! ***" << stl::endl;

    while (true)
    {
        stl::thread::sleepFor(500);
    }
}

// TODO: Add platform specific HardFault handlers/traps?

} // namespace stl::proces

#endif
